/*
 * Copyright 2004-2009 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.doma.internal.apt.meta;

import java.util.ArrayList;
import java.util.List;

import javax.lang.model.element.TypeElement;
import javax.lang.model.type.TypeMirror;

/**
 * 
 * @author taedium
 * 
 */
public class DaoMeta {

    protected final List<QueryMeta> queryMetas = new ArrayList<QueryMeta>();

    protected TypeMirror configType;

    protected boolean configAdapter;

    protected AnnotateWithMeta annotateWithMeta;

    protected TypeMirror daoType;

    protected TypeElement daoElement;

    protected String name;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public TypeMirror getConfigType() {
        return configType;
    }

    public void setConfigType(TypeMirror configType) {
        this.configType = configType;
    }

    public TypeMirror getDaoType() {
        return daoType;
    }

    public void setDaoType(TypeMirror daoType) {
        this.daoType = daoType;
    }

    public TypeElement getDaoElement() {
        return daoElement;
    }

    public void setDaoElement(TypeElement daoElement) {
        this.daoElement = daoElement;
    }

    public void addQueryMeta(QueryMeta queryMeta) {
        queryMetas.add(queryMeta);
    }

    public List<QueryMeta> getQueryMetas() {
        return queryMetas;
    }

    public boolean isConfigAdapter() {
        return configAdapter;
    }

    public void setConfigAdapter(boolean configAdapter) {
        this.configAdapter = configAdapter;
    }

    public AnnotateWithMeta getAnnotateWithMeta() {
        return annotateWithMeta;
    }

    public void setAnnotateWithMeta(AnnotateWithMeta annotateWithMeta) {
        this.annotateWithMeta = annotateWithMeta;
    }

}
